/* Primerite ja koristat bibliotekata GLUT koja ne e standarden del od OpenGL i
 * najchesto dopolnitelno se instalira vo vashata razvojna okolina
 */
#include <GL/glut.h>

/* Funkcija za iscrtuvanje, koj e nameneta da bide povikana sekogash koga kje
 * bide potrebno da se iscrta OpenGL delot od prozorecot. Ova se zadava na
 * pochetokot na programata pri inicijalizacijata na OpenGL so pomosh na GLUT
 */
void display(void)
{
   /* izbrishi gi site pixel-i na ekranot  */
   glClear (GL_COLOR_BUFFER_BIT);

   /* nacrtaj sharen pravoagolnik shto se prostira  
    * od (0.25, 0.25, 0.0) do (0.75, 0.75, 0.0)
    * vnimavajte kolkav del od ekranot zafakja  
    */
   glBegin(GL_QUADS);   /* Sekoja figura pochnata so glBegin zavrshuva so End, 
                         * ne e dozvoleno vgnezduvanje
                         */
      glColor3f (0.0, 0.0, 0.0);    /* Boite odat so Red, Green, Blue vrednost, 
                                     * soodvetno na inicijalizija vo main
                                     */
      glVertex3f (0.25, 0.25, 0.0); /* x, y, z koordinati */

      glColor3f (1.0, 0.0, 0.0);
      glVertex3f (0.75, 0.25, 0.0);

      glColor3f (0.0, 1.0, 0.0);
      glVertex3f (0.75, 0.75, 0.0);

      glColor3f (0.0, 0.0, 1.0);
      glVertex3f (0.25, 0.75, 0.0);
   glEnd();

   /*   
    * pushti gi da se iscrtaat dosega izdadenite OpenGL komandi 
    */
   glFlush ();
}

/* Funkcija nameneta da bide povikana samo ednash na pochetokot na programata
 * i da postavi nekoi osnovni detali od nashata scena, koi ne mora da se 
 * postavuvaat pri sekoe iscrtuvanje na scenata
 */
void init (void) 
{
   /* izberi boja koja kje se koristi za brishenje na prozorecot
    * faktichki boja na pozadina
	*/
   glClearColor (1.0, 1.0, 0.8, 0.0);

   /* inicijalizacija na vrednostite na proekcijata koja se koristi  
    * iako ovoj primer e 2d, vo OpenGL vsushnost nema 2d grafika, se e vo 3d;
    * najprvo aktivirame mod vo koj site postavuvanje se odnesuvaat na 
    * matricata na proekcija od 3d vo 2d 
    */
   glMatrixMode(GL_PROJECTION); 
   
   /* se vrakjame na apsolutniot koordinaten pochetok - reset na proekcijata */
   glLoadIdentity(); 

   /* Zadavame ortogonalna proekcija takva shto prostorot koj go gledame vo 
    * prozorecot e tochno delot ogranichen so slednite intervali
    *  0..1 po x po horizontala
    *  0..1 po y po vertikala
    * -1..1 po z vo dlabochina/dalechina
    */
   glOrtho(0.0, 1.0, 0.0, 1.0, -1.0, 1.0);    
}

/* 
 * Glavna funkcija
 * Deklariraj inicjalna golemina na prozorec, pozicija i mod na prikazhuvanje
 * (Single Buffer i RGB).  Otvori prozorec so naslov "Primer za vezhbi".
 * Povikaj gi inicijalizaciskite rutini.
 * Registriraj callback funkcija za prikaz na grafikata.
 * Zapochni ja main jamkata i procesiraj gi site nastani.
 */
int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   /* Vazhni inicijalizaciski parametri za razlichni osobini na OpenGL 
    * treba da bidat vo sklad postaveni so celiot nachin na rabota potoa
    */
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
  
   glutInitWindowSize (250, 250); 
   glutInitWindowPosition (100, 100);
   glutCreateWindow ("Primer za vezhbi");
   /* Nasha funkcija za inicijalizacija so raboti koi ne mora da se izvrshuvaat
    * pri sekoe iscrtuvanje, so cel da shtedime resursi
    */
   init ();
   
   /* Ja registrirame nashata funkcija display da se povika na sekoe crtanje */
   glutDisplayFunc(display); 
   
   /* beskonechen ciklus vo koj vrti aplikacijata se dodeka ne se prekine */
   glutMainLoop();

   /* ANSI C - main mora da vrakja vrednost, 0 e ako e se vo red */
   return 0;   
}

